#!/bin/bash

############################################################################
#
# MODULE:       GUI
# AUTHOR(S):    CacheGuard Development Team
# COPYRIGHT:    (C) 2009-2020 by CacheGuard Technologies Ltd
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#
###########################################################################

show-cancel-form()
{
    local width
    local diff=/tmp/conf.diff.${$}

    show-title "Cancel New Configuration" enabled "cancel"
    execute-command-with-output "conf diff" > ${diff}
    local ret=${?}

    show-form "${width}" enabled
    echo "<div style='clear:left;'></div>"

    echo "<div class='core-form'>"
    echo "<div class='table-title'>Running Configuration <strong>vs</strong> New Configuration</div>"

    echo "<table class='highlight-list' width='100%'>"
    if test ${ret} -eq 0 ; then
        if test -s "${diff}" ; then
	    local line
	    while read line
	    do
		echo "<tr>${line}</tr>"
	    done < ${diff}
	    rm -f ${diff}
        else
            echo "<tr><td><div class='table-title'>The new and running configurations are identical.</div></td></tr>"
        fi
    else
        echo "<tr><td><div class='table-title'>Configuration differences are not available.</div></td></tr>"
    fi
    echo '</table>'

    show-scroll-top
    echo "</div>"
}

# Main()

show-cancel-form
