#!/bin/bash

############################################################################
#
# MODULE:       GUI
# AUTHOR(S):    CacheGuard Development Team
# COPYRIGHT:    (C) 2009-2020 by CacheGuard Technologies Ltd
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#
###########################################################################

source countries.${GUI_EXT_NAME}

show-ca-generate-form()
{
    itemWidth[0]=25
    itemWidth[1]=75

    local days name country province locality organisation unit

    itemTitle[0]="CA Link"
    itemTitle[1]="Common Name"
    itemTitle[2]="Validity Days"
    itemTitle[3]="Country Code"
    itemTitle[4]="Province Name"
    itemTitle[5]="Locality Name"
    itemTitle[6]="Organisation Name"
    itemTitle[7]="Unit Name"

    itemID[0]="ca_links"
    itemID[1]="name"
    itemID[2]="days"
    itemID[3]="country"
    itemID[4]="province"
    itemID[5]="locality"
    itemID[6]="organisation"
    itemID[7]="unit"

    name="${VALUES[0]}"
    days="${VALUES[1]}"
    country="${VALUES[2]}"
    province="${VALUES[3]}"
    locality="${VALUES[4]}"
    organisation="${VALUES[5]}"
    unit="${VALUES[6]}"

    local web_ip=$(get-web-ip cur)

    blankItemContent[0]="<a href='http://${web_ip}' target='_blank'>${web_ip}</a> (available from the internal interface)"
    blankItemContent[1]="type='text' size='24' maxlength='32' value='${name}'"
    blankItemContent[2]="type='text' size='8' maxlength='8' value='${days}'"
    blankItemContent[3]=$(show-country ${country})
    blankItemContent[4]="type='text' size='24' maxlength='32' value='${province}'"
    blankItemContent[5]="type='text' size='24' maxlength='32' value='${locality}'"
    blankItemContent[6]="type='text' size='24' maxlength='32' value='${organisation}'"
    blankItemContent[7]="type='text' size='24' maxlength='32' value='${unit}'"

    checkItem[1]=printable
    checkItem[2]=digit
    checkItem[4]=printable
    checkItem[5]=printable
    checkItem[6]=printable
    checkItem[7]=printable

    itemForm[0]="text"
    itemForm[3]="select"

    show-title "Generate The system CA Certificate" "enabled" "tls"

    show-form "${width}" enabled

    echo '<script type="text/javascript">'
    echo "doNothingOnEnterInInput( 'names' );"
    echo "AJAX_updateTLSConf( '/${GUI_DIR_NAME}/tls-print.${GUI_EXT_NAME}?CA+conf+ca', 'name', 'days', 'country', 'province', 'locality', 'organisation', 'unit' );"
    echo '</script>'
}

# Main()

show-ca-generate-form "${@}"
