#!/bin/bash

############################################################################
#
# MODULE:       GUI
# AUTHOR(S):    CacheGuard Development Team
# COPYRIGHT:    (C) 2009-2020 by CacheGuard Technologies Ltd
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#
###########################################################################

source functions
check-cgi-security
read-post-data
try-authenticate
verify-authentication
AUTH_STATE=${?}

if test ${AUTH_STATE} -eq 0 ; then
    set-user-cookie
    gui-init-env
    init-env
    INITENV_STATUS=${?}
    echo-http-header
    cat ${ETC_HTML_DIR}/head-top.html
else
    echo-http-header
    cat ${ETC_HTML_DIR}/head-login-top.html
fi

cat ${ETC_HTML_DIR}/head-bottom.html
gen-body-top "tls-client" ""
echo "<noscript>"
echo "<table width='100%'>"
echo "<tr>"
echo "<td width='20%' bgcolor='FireBrick' valign='center'><center><font size='2' color='White'><strong>Web GUI error</strong></font></center></td>"
echo "<td width='80%' bgcolor='Lavender' valign='center'>"
echo "<font size='5' color='FireBrick'>"
echo "<center>JavaScript is disabled</center>"
echo "</font>"
echo "</td>"
echo "</tr>"
echo "<tr>"
echo "<td width='20%' bgcolor='Gainsboro'></td>"
echo "<td width='80%' bgcolor='Gainsboro' valign='center'><font size='2' color='DarkSlateGray'>The requested page contains JavaScript codes that could not be executed</font></td>"
echo "</tr>"
echo "<tr>"
echo "<td width='20%' bgcolor='Gainsboro'></td>"
echo "<td width='80%' bgcolor='Gainsboro' valign='center'><font size='2' color='DarkSlateGray'>Your browser doesn't support JavaScript or you've disabled this feature</font></td>"
echo "</tr>"
echo "<tr>"
echo "<td width='20%' bgcolor='Gainsboro'></td>"
echo "<td width='80%' bgcolor='Gainsboro' valign='center'><font size='2' color='DarkSlateGray'>Note that the system may also be configured using online commands via the Console port or SSH</font></td>"
echo "</tr>"
echo "</table>"
echo "</noscript>"

cat ${ETC_HTML_DIR}/top-begin.html
test ${AUTH_STATE} -ne 0 || show-title-check-usage
echo "  </div>"

echo "  <div class='header-right'>"
if test ${AUTH_STATE} -eq 0 ; then
    echo "    <script type='text/javascript' src='${JS_DIR}/ddtooltip.js'></script>"
    echo "    <div id='logout-iconbar'><a class='iconbar-item' href='#' style='float:right;margin-left:10px;' onClick='requestLogout( );'><img src='/image/exit-reflect.png' alt='Logout' title='Logout' /></a></div>"
fi
cat ${ETC_HTML_DIR}/top-end.html

if test ${AUTH_STATE} -eq 0 ; then
    echo "<div class='top-info'>"
    echo "<div style='float:left;'>"
    display-left-header-info
    echo "</div>"
    echo "<div style='float:right;'>"
    echo "<div class='top-menu-arrow' id='top-menu-arrow' title='Show/Hide Top Menu'></div>"
    echo "<div style='float:right;'>"
    display-right-header-info
    echo "</div>"
    echo "</div>"
    echo "</div>"
    echo "<div style='clear:left;'></div>"
    if test ${INITENV_STATUS} -eq 0 ; then
	echo "<table width='100%'><tr><td valign='top'>"
	show-left-menu
	echo "</td><td valign='top' width='100%'>"
	show-top-menu
	echo "<div class='core' id='core' name='core'>"
	source tls-client-core.apl
	echo "</div>"
	echo "</td><tr></table>"
    else
	gen-gui-error 12
	show-title-errors
    fi
else
    echo "<div class='core' id='core' name='core'>"
    source login-core.apl
    echo "</div>"
fi

call-js-function "initAutoLogout( )"
show-footer
gen-body-bottom
gen-bottom-html
