#!/bin/bash

############################################################################
#
# MODULE:       GUI
# AUTHOR(S):    CacheGuard Development Team
# COPYRIGHT:    (C) 2009-2020 by CacheGuard Technologies Ltd
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#
###########################################################################

print-revoke-reasons()
{
    echo -n "active keyCompromise CACompromise affiliationChanged superseded cessationOfOperation unspecified"
}

show-rweb-tls()
{
    local get_args=${1}
    local page_ref=$(get-arg-value "${get_args}" page)

    local width=500
    local state tls revoke

    itemWidth[0]=5
    itemWidth[1]=30
    itemWidth[2]=25

    itemTitle[0]=""
    itemTitle[1]="Identifier"
    itemTitle[2]="Revoke Status"

    itemForm[2]="select"
    
    itemID[0]="TLS"
    itemID[1]="tls"
    itemID[2]="status"
    
    blankItemContent[0]=""
    blankItemContent[1]="type='text' size='${MAX_NAME_LEN}' maxlength='${MAX_NAME_LEN}'"
    blankItemContent[2]=$(print-revoke-reasons)

    checkItem[1]=tls

    editColumnPage[0]="tls-load-save"
    editColumnPage[1]="tls-generate"

    editColumnTitle[0]="Load<hr />Save"
    editColumnTitle[1]="Gen"
    
    unset listContent

    for tls in ${TLS_LIST}
    do
	if test -f ${TMP_DIR}/${tls}.${TLS}.2rev ; then
	    revoke=$(cat ${TMP_DIR}/${tls}.${TLS}.2rev 2> /dev/null)
	elif test -f ${SSL_DIR}/${tls}.revoked ; then
	    revoke=$(cat ${SSL_DIR}/${tls}.revoked 2> /dev/null)
	else
	    revoke='active'
	fi

	listContent="${listContent} ${tls} ${revoke}"
    done

    listContent="${listContent:1}"
    listContentStep=2

    test -n "${listContent}" || state=disabled

    show-title "Manage Server TLS" "${state}" "tls rweb admin"
    show-list-form ${RWEB_NB} ${width} "${page_ref}"
}

# Main()

show-rweb-tls "${@}"
