#!/bin/bash

############################################################################
#
# MODULE:       GUI
# AUTHOR(S):    CacheGuard Development Team
# COPYRIGHT:    (C) 2009-2020 by CacheGuard Technologies Ltd
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#
###########################################################################

source countries.${GUI_EXT_NAME}

show-tls-generate-form()
{
    local get_args=${1}
    local tls=$(get-arg-value "${get_args}" key)

    if test -z "${tls}" ; then
	redirect-page "tls"
	return 0
    fi

    local width

    itemWidth[0]=25
    itemWidth[1]=75

    local days names country province locality organisation unit sign

    itemTitle[0]="Hidden"
    itemTitle[1]="TLS ID"
    itemTitle[2]="Common Name(s)"
    itemTitle[3]="Validity Days"
    itemTitle[4]="Country Code"
    itemTitle[5]="Province Name"
    itemTitle[6]="Locality Name"
    itemTitle[7]="Organisation Name"
    itemTitle[8]="Unit Name"
    itemTitle[9]="Sign with the CA?"

    itemID[0]="tls"
    itemID[1]="not_posted"
    itemID[2]="names"
    itemID[3]="days"
    itemID[4]="country"
    itemID[5]="province"
    itemID[6]="locality"
    itemID[7]="organisation"
    itemID[8]="unit"
    itemID[9]="sign"

    names="${VALUES[1]}"
    days="${VALUES[2]}"
    country="${VALUES[3]}"
    province="${VALUES[4]}"
    locality="${VALUES[5]}"
    organisation="${VALUES[6]}"
    unit="${VALUES[7]}"

    if test -f /tmp/${tls}.tls-id.2sign ; then
	sign=" checked"
    else
	! check-tls-cert-signed-by-ca ${tls} || sign=" checked"
    fi

    blankItemContent[0]="value='${tls}'"
    blankItemContent[1]="${tls}"
    blankItemContent[2]="cols='48' rows='3'"
    blankItemContent[3]="type='text' size='8' maxlength='8' value='${days}'"
    blankItemContent[4]=$(show-country ${country})
    blankItemContent[5]="type='text' size='24' maxlength='32' value='${province}'"
    blankItemContent[6]="type='text' size='24' maxlength='32' value='${locality}'"
    blankItemContent[7]="type='text' size='24' maxlength='32' value='${organisation}'"
    blankItemContent[8]="type='text' size='24' maxlength='32' value='${unit}'"
    blankItemContent[9]="type='checkbox'${sign}"

    checkItem[2]=text
    checkItem[3]=digit
    checkItem[4]=alphanum
    checkItem[5]=printable
    checkItem[6]=printable
    checkItem[7]=printable
    checkItem[8]=printable

    itemForm[0]="hidden"
    itemForm[1]="text"
    itemForm[2]="textarea"
    itemForm[4]="select"

    itemValue[2]=${names}

    show-title "Generate Server TLS" "enabled" "tls"

    show-form "${width}" enabled

    echo '<script type="text/javascript">'
    echo "doNothingOnEnterInInput( 'names' );"
    echo "AJAX_updateTLSConf( '/${GUI_DIR_NAME}/tls-print.${GUI_EXT_NAME}?${tls}+conf', 'names', 'days', 'country', 'province', 'locality', 'organisation', 'unit' );"
    echo '</script>'
}

# Main()

show-tls-generate-form "${@}"
