#!/bin/bash

############################################################################
#
# MODULE:       GUI
# AUTHOR(S):    CacheGuard Development Team
# COPYRIGHT:    (C) 2009-2020 by CacheGuard Technologies Ltd
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#
###########################################################################

show-tls-objects()
{
    local in_tls=${1}

    local selected tls

    for tls in ${TLS_LIST}
    do
	if test "${in_tls}" == ${tls} ; then
	    selected=' selected'
	else
	    unset selected
	fi

	echo -n "<option value='${tls}' id='${tls}'${selected}>${tls}</option>"
    done
}

show-ocsp-days()
{
    local days=${1}

    local i max=31

    for ((i=1 ; i<=max ; i++))
    do
	if test ${i} -eq ${days} ; then
	    selected=' selected'
	else
	    unset selected
	fi
	echo -n "<option value='${i}' id='${i}'${selected}>${i}</option>"
    done
}

show-tls-ocsp-etc()
{
    local width=400 i=0

    itemWidth[0]=50
    itemWidth[1]=50

    itemTitle[${i}]="Web Administration & SNMP TLS Object" ; ((i++))
    itemTitle[${i}]="Client Certificates Validity Days" ; ((i++))
    itemTitle[${i}]="OCSP Responder Network Name" ; ((i++))
    itemTitle[${i}]="OCSP Responder Port Number" ; ((i++))
    itemTitle[${i}]="OCSP Response Validity Days" ; ((i++))

    i=0
    itemID[${i}]="admin_tls" ; ((i++))
    itemID[${i}]="tls_client_days" ; ((i++))
    itemID[${i}]="tls_ocsp_host" ; ((i++))
    itemID[${i}]="port_ocsp" ; ((i++))
    itemID[${i}]="tls_ocsp_days" ; ((i++))

    i=0
    itemForm[${i}]="select" ; ((i++))
    itemForm[${i}]="input" ; ((i++))
    itemForm[${i}]="input" ; ((i++))
    itemForm[${i}]="input" ; ((i++))
    itemForm[${i}]="select" ; ((i++))

    i=0
    blankItemContent[${i}]=$(show-tls-objects ${ADMIN_TLS}) ; ((i++))
    blankItemContent[${i}]="type='text' size='8' maxlength='8' value='${TLS_CLIENT_DAYS}'" ; ((i++))
    blankItemContent[${i}]="type='text' size='32' maxlength='64' value='${OCSP_HOST}'" ; ((i++))
    blankItemContent[${i}]="type=text size=5 maxlength=5 value='${OCSP_PORT}'" ; ((i++))
    blankItemContent[${i}]=$(show-ocsp-days ${OCSP_DAYS}) ; ((i++))

    i=0
    checkItem[${i}]=tls ; ((i++))
    checkItem[${i}]=digit ; ((i++))
    checkItem[${i}]=domainname ; ((i++))
    checkItem[${i}]=digit ; ((i++))
    checkItem[${i}]=digit ; ((i++))

    shortcutMenuItem[0]="tls"
    shortcutMenuTitle[0]="Manage Server TLS"

    shortcutMenuItem[1]="port"
    shortcutMenuTitle[1]="Listening Ports"

    show-title "OCSP and Other TLS Settings" "enabled" "admin port tls"
    show-shortcuts-menu
    show-form "${width}"
}

# Main()

show-tls-ocsp-etc
